#ifndef NBBY
  #define NBBY 8     /* number of bits in a byte */
#endif

/*
 * Select uses bit masks of file descriptors in longs.  These macros
 * manipulate such bit fields (the filesystem macros use chars).
 * FD_SETSIZE may be defined by the user, but the default here should
 * be enough for most uses.
 */
#ifndef FD_SETSIZE
  #define FD_SETSIZE 256
#endif

typedef long fd_mask;
#ifndef NFDBITS
  #define NFDBITS (sizeof(fd_mask) * NBBY)    /* bits per mask */
#endif

#ifndef howmany
  #define howmany(x, y) (((x)+((y)-1))/(y))
#endif

typedef struct fd_set {
 fd_mask fds_bits[howmany(FD_SETSIZE, NFDBITS)];
} fd_set;

#define FD_SET(n, p)   ((p)->fds_bits[(n)/NFDBITS] |= (1 << ((n) % NFDBITS)))
#define FD_CLR(n, p)   ((p)->fds_bits[(n)/NFDBITS] &= ~(1 << ((n) % NFDBITS)))
#define FD_ISSET(n, p) ((p)->fds_bits[(n)/NFDBITS] & (1 << ((n) % NFDBITS)))
#define FD_ZERO(p)     bzero((char *)(p), sizeof(*(p)))
